CSECT OPEN1
cloli program to contain all file openings and some stops
cloli subs open1,help1
cloli   open1.f created together with iopt.f  open2.f and sterr.f
cloli iunisa: number of unis

c ------------------------------------------------------------------
      subroutine open1
      parameter (nperm=6,nscr=7,nscr1=5,nold=2,largon=100)
      parameter (npermd=nperm-nold)
c     next parameters need to be the same in iopt.f and open2.f 
      parameter (nguard=4,noptm=5)
c      tapes.inc contains the symbolic names
      common /TAPES/ iunisa(14)
        character*6 identi(14) 
        data identi /'iqqout','iqqinp','iqqlbm','iqqlbt','iqqutl'
     *              , 'iqqpgm','iqqdat','iqqpch','iqqutb','iqqmdl'
     *              ,'iqqltr','iqqact','iqqtmp','iqqbin'/
c     "same" order as in tapes.inc and blkdat.f
      common /filens/ files(nguard)
        character*100 argum,files,filew,filen,homed
        data files /nguard*''/
c       if names are longer than 100 they get truncated
c       file's attributes
        dimension indp(nperm),indfip(nperm),inds(nscr)
        character*4 exten(nperm)
          data exten /'',    '',    '.ls1','.for','.ini','.acs'/
        character*7 stats(nperm), stat
          data stats /nold*'old    ',npermd*'unknown'/
      common /opciones/ optgs(noptm)
        character*8 optgs
        data optgs /'help','version','modellib','outdir',''/
      character*1 bardir
        data bardir /'/'/
      character*2 pre
        data pre /'./'/ 
c permanent unis; indp:index in iunixa, indfip: index in files
c             iqqinp,iqqlbm,iqqout,iqqpgm,iqqdat,iqqact
      data indp / 2,     3,     1,     6,     7,     12/
      data indfip /1,    2,     3,     3,     3,     3 /
c scratch unis; inds: index in iunisa
c               iqqlbt,iqqutl,iqqutb,iqqpch,iqqltr,iqqtmp,iqqbin
      data inds / 4,      5,     9,     8,     11,    13,     14/

c     ANALIZE OPTIONS AND ARGUM TO GET files
c       files(1): name of input file without .d and without dir part
c       files(2); complete name of modellib.dat
c       files(3): outdir                
c        option -m indicates that  next "is" modellib.dat;
c          goes to files(2)
c    option -o indicates that next is outputdir 
c      argum is name of input file with or withot .d;
c           with dir part if necessary
c     1 argument needed;
c     4 possible options: help, version, modellib, outdir;
c         with -- or - for just first letter
c     the 2 first options dont need a value;
c     the 2 last  options need a value; if not ... stop

      icode=iopt(1,4,2,2)
      if (icode. eq. 1) then
          call help1
      else if (icode .eq. 2) then
          call vers
          stop
      else if (icode .gt. 2) then
          print *,'sceptre1: errors in calling'
          stop 206
      end if
      if (files(2).eq.'') then
          call getenv('HOME',homed)
          largoh=lenoc(homed)
          files(2)(1:largoh)=homed(1:largoh)
          files(2)(largoh+1:)='/lib/modellib.dat'
      endif
      largo2=lenoc(files(2))
      print *,'Model file: ',files(2)(1:largo2)  

      largo1=lenoc(files(1))
      argum= files(1)
      if((largo1 .gt. 2) .and. (argum(largo1-1:largo1) .eq. '.d')) 
     *    argum=argum(1:largo1-2)
      largo1=lenoc(argum)
      files(1)(1:largo1)=argum
      files(1)(largo1+1:largo1+2)='.d'
      do 20, i=largo1,1,-1
          if(argum(i:i) .eq. bardir) go to 30
 20   continue
      i=0
 30   if (i .eq. largo1) then
         print *,'OPEN1: files(1) ',files(1)
     *, 'is not good for input file name'
         print *,'sceptre1: errors in calling'
         stop 207
      else 
         if ((files(1)(1:1) .ne. bardir) .and. (files(1)(1:1) .ne. '.'))
     *   then
            files(1)(3:largon) = files(1)(1:largon-2)
            files(1)(1:2) = pre
         end if
         largo1 = lenoc(files(1))
         print *,'Input file: ',files(1)(1:largo1)
      end if

      argum=argum(i+1:)
      if ((files(3) .ne. '') .and. (files(3) .ne. '.')
     *     .and. (files(3) .ne. './')) then
          largo3=lenoc(files(3))
          if (files(3)(largo3:largo3) .ne. bardir)then
              files(3)(largo3+1:largo3+1)=bardir
              largo3=lenoc(files(3))
          end if
          filew(1:largo3)=files(3)
          filew(largo3+1:)=argum
      else
          filew(1:1)='.'
          filew(2:2)=bardir
          filew(3:)=argum
      end if
      largo3=lenoc(filew)
      print *,'Generic name of output files: ',filew(1:largo3)
      files(3)=filew
 
      do 50,i=1,nperm
          filen=files(indfip(i))
          largo=lenoc(filen)
          filen(largo+1:largo+4)=exten(i)
          iunit=iunisa(indp(i))
          stat = stats(i)
          open (unit=iunit,err=900,iostat=iostat,
     *          file=filen,
     *          status=stat)
          rewind iunit
 50   continue    
cloli added to process 'continue' input files
      iqqcnt=83
      open (unit=iqqcnt,iostat=iostat,
     *     file='datasave.dat',
     *     status='unknown')
      iqqcnt=84
      open (unit=iqqcnt,iostat=iostat,
     *     file='pgmsave.for',
     *     status='unknown')

c     need filen without dir part to create new files in work dir

      filen='scratch'
      stat='scratch'
      do 200, i=1,nscr1
          iunit=iunisa(inds(i)) 
          open(unit=iunit,err=900,iostat=iostat,status=stat)
          rewind iunit
 200  continue    
      filen='scratch_unformatted'
      do 300, i=nscr1+1,nscr
          iunit=iunisa(inds(i)) 
          open (unit=iunit,err=900,iostat=iostat,
     *             form='unformatted',status=stat)
          rewind iunit
 300  continue
      return

 900  largo=lenoc(filen)
      print *,'OPEN1: open error - file: ',filen(1:largo) 
      print *,'                  - unit: ',iunit
      print *,'                  - stat: ',stat
      print *,'                  - iostat: ',iostat      
      print *, filen(1:largo),' could not be opened'
      print *,'STOP sceptre1: errors in calling'
      stop 208
      end
c --------------------------------------------------------------------
      subroutine help1
      print *,"Usage: sceptre1 [option...] argum"
      print *," Options without an argument:"
      print *,"  --help -h       Display this help and exit"
      print *,"  --version -v    Show version information and exit"
      print *," Options with an argument:"
      print *,"  --modellib, -m  Name of file with model descriptions"
      print *,"                  Default: $HOME/lib/modellib.dat"
      print *,"  --outdir, -o    Name of directory to receive out files"
      print *,"                  Default: working directory"
      print *," Argument:"  
      print *,"  argum           Name of file with circuit description"
      stop
      end
